var EventEmitter;
var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
EventEmitter = require('events').EventEmitter;
module.exports = (function() {
  function exports(options) {
    this.setup();
    this.events = new EventEmitter;
    this.polling = false;
    this.timer = null;
  }
  exports.prototype.on = function(event, listener) {
    this.events.on(event, listener);
    if (this.events.listeners(event).length === 1) {
      this.events.on('incoming', __bind(function() {
        if (this.timer) {
          clearTimeout(this.timer);
        }
        return this.poll();
      }, this));
    }
    return this.poll();
  };
  exports.prototype.poll = function(from) {
    if (this.polling) {
      return;
    }
    this.polling = true;
    return this.peek(__bind(function(err, obj) {
      if (err) {
        return this.events.emit('error', err);
      } else {
        if (obj) {
          return this.events.emit('message', obj.data, __bind(function(err) {
            if (err) {
              return this.reschedule(obj, null, __bind(function(err) {
                this.polling = false;
                return this.poll();
              }, this));
            } else {
              return this.remove(obj.id, __bind(function() {
                this.polling = false;
                return this.poll();
              }, this));
            }
          }, this));
        } else {
          return this.poll_in(1);
        }
      }
    }, this));
  };
  exports.prototype.poll_in = function(sec) {
    this.polling = false;
    return this.timer = setTimeout(__bind(function() {
      return this.poll();
    }, this), sec * 1000);
  };
  exports.prototype.setup = function() {};
  return exports;
})();